/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: r_rdcr.c,v 1.2 1997/09/25 17:49:33 ae59 Exp $ */
/*
$Log: r_rdcr.c,v $
 * Revision 1.2  1997/09/25  17:49:33  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:09  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : r_rdcr.c                              */
/*                                                              */
/*      Entries         : void r_rdcr(device,s,rnd,i)           */
/*                        FILE *device;                         */
/*                        a_real *s;                            */
/*                        a_intg rnd;                           */
/*                        int i;                                */
/*                                                              */
/*      Arguments       : device - input device reading string  */
/*                        s - resultant IEEE variable           */
/*                        rnd - rounding mode                   */
/*                              -1 = rounding downwards         */
/*                               0 = round to nearest           */
/*                               1 = round upwards              */
/*                        i - window character                  */
/*                                                              */
/*      Description     : Read a character string from input    */
/*                        device and convert to real format     */
/*                                                              */
/*      Note            : rounding ignored                      */
/*                                                              */
/*      Date            : 1990-11-12                            */
/*      1990-11-12 : b_cfrm removed / E_TPUSH+E_TPOPP           */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern dotprecision b_cp__;
#endif

#ifdef LINT_ARGS
local void r_rdcr(FILE *device,a_real *s,a_intg rnd,int i)
#else
local void r_rdcr(device,s,rnd,i)

FILE *device;
a_real *s;
a_intg rnd;
int i;
#endif
        {
        a_intg dp,expo,length;
        a_bool sign;

        E_TPUSH("r_rdcr")

        switch (b_cscn(device,(char *)b_cp__,&expo,&dp,&length,&sign,i))
           {
           case  1:
           case  2:
           case  3:
           case  6:
           case  7:
           case  8: e_trap(I_O_ERROR,2,E_TMSG,58);
                    E_TPOPP("r_rdcr")
                    return;
           case  4:
           case  5: e_trap(I_O_BUFFER,2,E_TMSG,56);
                    E_TPOPP("r_rdcr")
                    return;
           case  9: e_trap(OVERFLOW,2,E_TMSG,56);
                    E_TPOPP("r_rdcr")
                    return;
           case 10: e_trap(UNDERFLOW,2,E_TMSG,56);
                    E_TPOPP("r_rdcr")
                    return;
           default: ;
           }

        ((char *)b_cp__)[length] = '\0';

        if (expo<DBL_MIN_10_EXP)
           e_trap(UNDERFLOW,2,E_TMSG,56);
        else if (expo>DBL_MAX_10_EXP-1)
           e_trap(OVERFLOW,2,E_TMSG,56);
        else if (sscanf((char *)b_cp__,"%le",s)==EOF)
           e_trap(I_O_ERROR,2,E_TMSG,20);

        E_TPOPP("r_rdcr")
        return;
        }
